Attribute VB_Name = "GA2D"
Option Explicit

Public Chk2DGA As Boolean
Public Chk2DGA_Bottom As Boolean


Public Type genotypeGA2D
           X(1 To 90) As Integer
End Type

Public pop2D() As genotypeGA2D
Public pop2D_Bottom() As genotypeGA2D

Public Function pop2D_Bottom_SubStruct_distribution_4m_SingleStructure(PopSource As String, posindex As Integer)
  
  Dim i As Integer
  Dim j As Integer
  Dim mystruct As genotype
  
  
  If PopSource = "old" Then
          mystruct = population(posindex)
  Else
          mystruct = newpopulation(posindex)
  End If
    
  
  'For i = 2 To HP.txtProteinLength - 1
  '    pop2D_Bottom(i).X(HP.txtProteinLength) = mystruct.X(HP.txtProteinLength)
  '    pop2D_Bottom(i).Y(HP.txtProteinLength) = mystruct.Y(HP.txtProteinLength)
  'Next i
  
   
  For i = HP.txtProteinLength To 3 Step -1
     For j = (i - 1) To 2 Step -1
      pop2D_Bottom(j).X(i) = mystruct.X(i)
      'pop2D_Bottom(j).Y(i) = mystruct.Y(i)
    Next j
  
  'Now compute the fitness and distribute the partial fitness
  '  pop2D_Bottom(i - 1).PF = SubStructFitness(mystruct, i, HP.txtProteinLength)
  
  Next i
  
End Function

Public Function pop2D_SubStruct_distribution_4m_SingleStructure(PopSource As String, posindex As Integer)
  
  Dim i As Integer
  Dim j As Integer
  Dim mystruct As genotype
  
  
  If PopSource = "old" Then
          mystruct = population(posindex)
  Else
          mystruct = newpopulation(posindex)
  End If
    
  
  For i = 2 To HP.txtProteinLength - 1
      pop2D(i).X(1) = mystruct.X(1)
      'pop2D(i).Y(1) = mystruct.Y(1)
  Next i
  
   
  For i = 2 To HP.txtProteinLength - 1
    For j = i To HP.txtProteinLength - 1
      pop2D(j).X(i) = mystruct.X(i)
      'pop2D(j).Y(i) = mystruct.Y(i)
    Next j
  
  'Now compute the fitness and distribute the partial fitness
    'pop2D(i).PF = SubStructFitness(mystruct, i, HP.txtProteinLength)
  
  Next i
  
End Function
Public Function Copy_1DGA_to_2DGA_Bottom(PopSource As String, posindex As Integer, n As Integer)

  Dim mystruct As genotype
  Dim i As Integer
  
  If PopSource = "old" Then
          mystruct = population(posindex)
  Else
          mystruct = newpopulation(posindex)
  End If


  For i = (n + 1) To HP.txtProteinLength
       pop2D_Bottom(n).X(i) = mystruct.X(i)
       'pop2D_Bottom(n).Y(i) = mystruct.Y(i)
  Next i
  
End Function

Public Function Copy_1DGA_to_2DGA(PopSource As String, posindex As Integer, n As Integer)

  Dim mystruct As genotype
  Dim i As Integer
  
  If PopSource = "old" Then
          mystruct = population(posindex)
  Else
          mystruct = newpopulation(posindex)
  End If


  For i = 1 To n
       pop2D(n).X(i) = mystruct.X(i)
       'pop2D(n).Y(i) = mystruct.Y(i)
  Next i
  
End Function
